<template>
    <fieldset class="calendar__wrap">
      <div class="flex">
          <div class="Calendar">
              <div 
                    class="Cr-Head" 
                    :class="{right: monthsRight}"
                    @click="monthsRight=!monthsRight"
                    >
                    <div class="Cr-Head_ltMonth" @click="ltMonth" v-if="currentData()">{{prevMonth()}}</div>
                    <div class="Cr-Head_currMonth">{{months[currMonth]}}</div>
                    <div class="Cr-Head_gtMonth" v-if="nextMonthArray == currentMonth+1" @click="gtMonth">{{nextMonth()}}</div>
              </div>
              <div class="Cr-Body">
                <div class="Cr-Week">
                    <div class="Cr-Week_day cl-column-7" v-for="day in days" v-bind:key="day">
                       <span class="squr">
                         <span class="squr-inner"> {{day}}</span>
                         </span>
                    </div>
                </div>
                <div class="Cr-Days" :class="{fadeAnim: monthsRight}"> <!---->
                    <div class="Cr-Days_blank cl-column-7" v-for="blank in daysOfPrevMonth" v-bind:key="blank">
                        <span class="squr">
                             <span class="squr-inner">{{blank}}</span>
                        </span>
                    </div>
                    <div 
                      class="cl-column-7" 
                      v-for="i in daysInMonth" 
                      v-bind:key="i"
                      :class="[
                          {currDay: i == currDay}, 
                          {clickedDay: i == clickedDay && i != currDay},
                          {'Cr-Days_day':i == currDay || (!currentData()? i >= validDate+1: i >=nextMonthsDay)},
                          {'Cr-Days_blank': !currentData()? i <= validDate: i <=nextMonthsDay }
                          ]" 
                      @click="!currentData()? 
                                    i <= validDate?
                                    null:setDate(i)
                                    :
                                    i <=nextMonthsDay?
                                    null:setDate(i);"
                      >
                      <span class="squr">
                         <span class="squr-inner">{{i}}</span>
                      </span>
                    </div>
                    <div class="Cr-Days_blank cl-column-7" v-for="i in qtyDaysNextMonth" v-bind:key="i">
                        <span class="squr">
                             <span class="squr-inner">{{i+1}}</span>
                        </span>
                    </div>
                </div>
            </div>
          </div>
      </div>
    </fieldset> 
</template>
<script>
const NOW = new Date();
export default {
    name: 'vueCallendar', 
    data (){
        return{ 
            inst_date: NOW,
            days: ['Lun', 'Mar', 'Mer', 'Jeu', 'Ven', 'Sam', 'Dim'],
            months: ['Janvier', 'Février', 'Mars', 'Avril', 'Mai', 'Juin', 'Juillet', 'Août', 'Septembre', 'Octobre', 'Novembre', 'Décembre'],
            clickedDay: NOW.getDate(),
            monthsRight: false,
            currentMonth: NOW.getMonth(),
            currentYear: NOW.getFullYear(),
            str: '',
            output: {
                format: '',
            },
            nextMonthsDay: '',
            validDate: NOW.getDate()+2,
        }
    },
    methods: {
        ltMonth() {
            this.clickedDay = null
            this.inst_date = new Date(this.currYear, this.currMonth - 1)
        },
        gtMonth() {
            if(this.validDate >= this.daysInMonth){
                this.nextMonthsDay = this.validDate-this.daysInMonth;
            }
            this.clickedDay = null
            this.inst_date = new Date(this.currYear, this.currMonth + 1)
        },
        reset() {
            this.clickedDay = null
            this.$emit('setdate', null)
        },
        setDate(day) {
            this.clickedDay = day
            const fixDay = day < 10 ? '0' + day : day

            const fixMonth =
                this.currMonth + 1 < 10
                    ? '0' + (this.currMonth + 1)
                    : this.currMonth + 1
            //this.str = `${day}.${fixMonth}.${this.currYear}`
            this.str = `${day} ${this.months[this.currMonth]} ${this.currYear}`
            this.output.format = `${this.currYear}-${fixMonth}-${fixDay}`
            this.$emit('setdate', {
                dataStr:this.str,
                dataFormat: new Date(this.currYear,fixMonth-1,fixDay, NOW.getHours(), NOW.getMinutes()),
                nextFormat: this.output.format
            });  
        },
        prevMonth(){
            return (this.currMonth>=1 ? this.months[this.currMonth-1] : this.months[11]);
        },
        nextMonth(){
            return (this.currMonth <= 10 ? this.months[this.currMonth+1] : this.months[0]); 
        },
        currentData(){
            return(this.currMonth == this.currentMonth && this.currYear == this.currentYear ? false : true)  
        },
        addDays(date, days) {
          let result = new Date(date);
          result.setDate(result.getDate() + days);
          return result;
        },
    },
    computed: {
        
        currYear() {
            return this.inst_date.getFullYear()
        },
        currMonth() {
            return this.inst_date.getMonth()
        },
        currWD() {
            return this.inst_date.getDay()
        },
        currDay() {
            if (
                this.inst_date.getMonth() === NOW.getMonth() &&
                this.inst_date.getFullYear() === NOW.getFullYear()
            ) {
                return NOW.getDate()
            }
            return null;
        },
        daysInMonth() {
            return new Date(this.currYear, this.currMonth + 1, 0).getDate()
        },
        _lastDateOfPrevMonth() {
            return new Date(this.currYear, this.currMonth, 0).getDate()
        },
        _qtyDaysPrevMonth() {
            return new Date(this.currYear, this.currMonth, 0).getDay()
        },
        daysOfPrevMonth() {
            return (
                this._qtyDaysPrevMonth &&
                Array.from(
                    { length: this._qtyDaysPrevMonth },
                    (v, k) => this._lastDateOfPrevMonth - this._qtyDaysPrevMonth + (k + 1)
                )
            )
        },
        qtyDaysNextMonth() {
            return 35 - (this.daysInMonth + this._qtyDaysPrevMonth)
        },
        nextMonthArray(){
            return this.currMonth + 1;
        },
    },
}

</script>
<style>
.flex {
   display: flex;
}

.calendar__wrap {
    padding-bottom: 40px;
    position: relative;
}

.Calendar {
   width: 100%;
   max-width: 100%;
   margin: auto;

   user-select: none;
   text-align: center;
}
.Cr-Head,
.Cr-Week,
.Cr-Days {
   display: flex;
}
.Cr-Head,
.Cr-Week {
   font-weight: 700;
}

.Cr-Head.right {
    justify-content: flex-end;
}

.Cr-Week {
   line-height: 2em;
}
.Cr-Week_day {
   width: 40px;
   color: #AF0037;
}
.Cr-Head {
   align-items: flex-end;
    line-height: normal;
}
.Cr-Head_currMonth {
   flex: 0 0 50%;
   max-width: 50%;
   background: #AF0037;
   color: #fff;
   border-radius: 5px 5px 0px 0;
   padding: 8px;
   font-size: 18px;
}
.Cr-Head_ltMonth,
.Cr-Head_gtMonth {
   flex: 0 0 30%;
   max-width: 30%;
   cursor: pointer;
   background: #E7E7E7;
   border-radius: 5px 5px 0px 0;
   padding: 5px;
   color: #97A4AC;
   font-size: 14px;
}
.Cr-Head_ltMonth{
    margin-right: 2%;
}

.Cr-Head_gtMonth{
    margin-left: 2%;
}

.Cr-Head_ltMonth:hover,
.Cr-Head_gtMonth:hover {
   background: #AF0037;
   color: #fff;
}

.Cr-Body{
    border: 1px solid #707070;
}

.Cr-Days {
   flex-wrap: wrap;
}
.Cr-Days_blank,
.Cr-Days_day {
   width: 40px;
}
.Cr-Days_blank {
   color: #dee2e6;
}
.Cr-Days_day {
   cursor: pointer; 
   padding: 4px;
}

.Cr-Days_day .squr{
    border-radius: 50%;
}
.Cr-Days_day.Cr-Days_blank.currDay{
    cursor: default;
}
.Cr-Days_day:hover:not(.currDay):not(.clickedDay) .squr{
   background: #dee2e6;
}
.Cr-Days .currDay .squr-inner{
    background: #54606E;
    color: #fff; 
}
.Cr-Days .clickedDay .squr{
     background: #AF0037;
     color: #fff;
     font-weight: bold;
}

.invalid-date .Cr-Body {
    border-color: #AF0037;
}

.prk-order__invalid-date{
    font-size: 12px;
    font-weight: 700;
    color: #AF0037;
    position: absolute;
    bottom: 0;
}

.cl-column-7 {
    width: 100%;
    flex: 0 0 14.28%;
    max-width: 14.28%; 
}

.squr {
    position: relative;

   display: inline-block;
   overflow: hidden;

   -webkit-box-sizing: border-box;
           box-sizing: border-box;
   width: 100%;
   min-width: 30px;
   max-width: 100%;
   height: auto;
   min-height: 30px;

   vertical-align: top;
   padding: 50%;
}


.squr-inner {
    position: absolute;
    top: 0;
    right: 0;
    bottom: 0;
    left: 0;
    display: flex;
    align-items: center;
    justify-content: center;
    width: 100%;
    max-width: 100%;
    height: 100%;
    max-height: 100%;
    margin: 0;
    padding: 0;
}

@keyframes fadein {
    from { opacity: 0; }
    to   { opacity: 1; }
}

@-moz-keyframes fadein {
    from { opacity: 0; }
    to   { opacity: 1; }
}


@-webkit-keyframes fadein {
    from { opacity: 0; }
    to   { opacity: 1; }
}


@-ms-keyframes fadein {
    from { opacity: 0; }
    to   { opacity: 1; }
}

@-o-keyframes fadein {
    from { opacity: 0; }
    to   { opacity: 1; }
}

.fadeAnim{
    -webkit-animation: fadein 2s; 
       -moz-animation: fadein 2s; 
        -ms-animation: fadein 2s; 
         -o-animation: fadein 2s; 
            animation: fadein 2s;
}
@media(max-width:992px){
    .calendar__wrap{
        padding-bottom: 70px;
    }
}
@media(max-width:767px){
    .prk-order__invalid-date{
        bottom: 15px;
    }
}

@media(max-width:570px){
    .calendar__wrap {
        padding-bottom: 30px;
    }
    .invalid-callendar {
        padding-bottom: 80px;
    }
}


</style>